#
## Makefile
#

LIBXML2_VER := libxml2@2.9.4
JANSSON_VER := jansson@2.7
LIBCONFIG_VER := libconfig@1.5

SOURCES.c= run_mvt.c mvt.c threshold_functions.c
$(CC)=gcc


LIBXML2_PATH := $(shell spack find -p $(LIBXML2_VER) | awk 'NR>1 {print $$NF}')
JANSSON_PATH := $(shell spack find -p $(JANSSON_VER) | awk 'NR>1 {print $$NF}')
LIBCONFIG_PATH := $(shell spack find -p $(LIBCONFIG_VER) | awk 'NR>1 {print $$NF}')

NETCDF_PATH := /qfs/people/tang584/install/netcdf-c
HDF5_PATH := /qfs/people/tang584/install/hdf5

SYSTEM_INCLUDE=/usr/include
SYSMTE_LIB64=/usr/lib64
SYSTEM_LIB=/usr/lib

CFLAGS=-W -Wall -I. -I$(LIBXML2_PATH)/include/libxml2 -I$(NETCDF_PATH)/include -I$(HDF5_PATH)/include -I$(LIBCONFIG_PATH)/include -I$(JANSSON_PATH)/include -I$(SYSTEM_INCLUDE) 
LDLIBS=-L$(LIBCONFIG_PATH)/lib -L$(LIBXML2_PATH)/lib -L$(JANSSON_PATH)/lib -L$(NETCDF_PATH)/lib64 -L$(HDF5_PATH)/lib #-L$(SYSMTE_LIB64) #-L$(SYSTEM_LIB)

LDFLAGS=-Wl,-rpath,$(LIBCONFIG_PATH)/lib $(LDLIBS) -lm -lnetcdf -lhdf5 -lhdf5_hl -ljansson -lconfig -lxml2 -lcurl


PROGRAM=mvt
OBJECTS= $(SOURCES.c:.c=.o)

$(PROGRAM): $(INCLUDES) $(OBJECTS)
	$(LINK.c) -o $@ $(OBJECTS) $(LDFLAGS)

clean:
	rm -f $(PROGRAM) $(OBJECTS)

checkp:
	@echo "LIBCONFIG_PATH: $(LIBCONFIG_PATH)"
	@echo "LIBXML2_PATH: $(LIBXML2_PATH)"
	@echo "JANSSON_PATH: $(JANSSON_PATH)"
	@echo "NETCDF_PATH: $(NETCDF_PATH)"
	@echo "HDF5_PATH: $(HDF5_PATH)"

install: all
	@echo "nothing to install"


# # Below are original code:
# CFLAGS=-Wall -I. -I/usr/local/include -I/usr/include/libxml2 -I/usr/local/jansson/include -I/usr/local/libconfig/include
# LDLIBS=-L/usr/local/jansson/lib -L/usr/local/libconfig/lib -lm -lnetcdf -ljansson -lconfig -lxml2